"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Disorder(ProtocolElement):
    """
    This is quite GEL specific. This is the way is stored in
    ModelCatalogue and PanelApp.     Currently all specific disease
    titles are assigned to a disease subgroup so really only
    specificDisease needs to be     completed but we add the others
    for generality
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import participant as participant_1_4_0

        return {
            "org.gel.models.participant.avro.Disorder": participant_1_4_0.Disorder,
        }

    __slots__ = [
        "ageOfOnset",
        "diseaseGroup",
        "diseaseSubGroup",
        "specificDisease",
    ]

    def __init__(
        self,
        ageOfOnset=None,
        diseaseGroup=None,
        diseaseSubGroup=None,
        specificDisease=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_4_0.Disorder model.

        :param ageOfOnset:
            Age of onset in years
        :type ageOfOnset: None | float
        :param diseaseGroup:
            This is Level2 Title for this disorder
        :type diseaseGroup: None | str
        :param diseaseSubGroup:
            This is Level3 Title for this disorder
        :type diseaseSubGroup: None | str
        :param specificDisease:
            This is Level4 Title for this disorder.         In GMS, this is the
            clinicalIndicationFullName/clinicalIndicationCode.
        :type specificDisease: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.4.0"
